/*
 *
 * This file is a part of gcd - gcd is an ncurses based audio CD player.
 *
 * Copyright (C) 1998  Geza Herman
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * Geza Herman
 * <hg211@ural2.hszk.bme.hu>
 *
 */

#ifndef  __DISPLAY_H
#include <curses.h>
#include <sys/types.h>

#define C_WHITE		( COLOR_PAIR( 1 ) | A_BOLD )
#define C_YELLOW	( COLOR_PAIR( 2 ) | A_BOLD )
#define C_CYAN		( COLOR_PAIR( 3 ) )
#define C_GREEN		( COLOR_PAIR( 4 ) | A_BOLD )
#define C_RED		( COLOR_PAIR( 5 ) | A_BOLD )
#define C_BLUE		( COLOR_PAIR( 6 ) )

#define	C_CURRENT	( C_YELLOW )
#define C_HIGHLIGHT	( COLOR_PAIR( 7 ) | A_BOLD )
#define C_CURRHIGH	( COLOR_PAIR( 8 ) | A_BOLD )
#define C_HIGHLIGHT_B	( COLOR_PAIR( 7 ) )

#define MKEY_ENTER '\r'
#define MKEY_ESC   27
#define MKEY_TAB   '\t'

#define IN_CANCEL 1
#define IN_ACCEPT 2
#define IN_AGAIN  3

struct input_inf {
    int	len, cursor, first;
    int cursory, y0;
    char *cl, *c;
    int updated;
    int modified;
};

void	init_display();
void	done_display();
void	init_screen();
void	print_discID( unsigned );
void	print_volume( u_char, u_char );
void	print_state( int );
void	print_cdtime( int, int, char );
void	print_tracktime( int, int, char );
void	print_cdtotal( int, int, int );
void    print_playmode( int, int );
void	print_ext( int, int, char * );
void	print_wh_ext( char * );
void	init_input( struct input_inf * );
int	input( int, int, int, char *, int, struct input_inf * );
int	input_ext( char *, int, struct input_inf * );
void	print_errormsg( char * );
int	cdtitle_max();
void	print_cdtitle( char *, int );
int	title_y();
int	title_x();
int	title_maxx();
int	title_maxy();
int	ext_h();
int	ext_w();
int	prog_maxy();
int	prog_maxx();
void	set_color( u_char, int, int, int );
void	print_title( int, int, u_char, char *, int, int, int, int, int, int, int, int, int );
void	delete_title();
void	print_prog( int, int, char *, int, int );
void	delete_prog( int );

#define  __DISPLAY_H
#endif   // __DISPLAY_H